Subject: Re: Bug#758105: bug#18266: grep -P and invalid exits with error

From: Vincent Lefevre <[email-masked]>
Date: Thu, 14 Aug 2014 19:44:42 +0200

On 2014-08-14 09:15:58 -0700, Paul Eggert wrote:
> That commit was necessary to avoid undefined behavior in libpcre.  We can't
> simply undo the commit (unless you want to reintroduce security holes into
> grep :-).  The current behavior is the best we can do, unless someone fixes
> libpcre (which doesn't appear to be likely), or unless someone takes the
> time to write code in grep to work around the problem.
> 
> One way forward is suggested in <http://bugs.gnu.org/17245#43>.  No doubt
> there are others.  Can you suggest a volunteer to take this on?

Discarding input lines with invalid UTF-8 sequences is not OK.
IMHO, it would be better to replace invalid UTF-8 sequences by
zero bytes before passing them to libpcre. Is it allowed to do
that in Pexecute()?

-- 
Vincent Lefèvre <[email-masked]> - Web: <https://www.vinc17.net/>
100% accessible validated (X)HTML - Blog: <https://www.vinc17.net/blog/>
Work: CR INRIA - computer arithmetic / AriC project (LIP, ENS-Lyon)